<template>
  <v-card>
    <v-toolbar color="white" height="48">
      <v-row>
        <v-col class="align-self-center ml-2">
          <v-row class="align-center">
            <v-col> Create Chart </v-col>
            <v-col align="right" class="pr-6">
              <v-btn
                size="big"
                variant="outlined"
                icon="mdi-close"
                class="open-close-btn-white"
                @click="$emit('close:dialog')"
              />
            </v-col>
          </v-row>
        </v-col>
      </v-row>
    </v-toolbar>
    <v-row>
      <v-col>
        <v-divider />
      </v-col>
    </v-row>
    <v-card-text>
      <v-row>
        <v-col>
          <v-text-field
            label="Name"
            v-model="name"
            :error-messages="nameError"
            variant="outlined"
          ></v-text-field>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12"> Chart type </v-col>
      </v-row>
      <v-row>
        <v-col v-for="c in chartType" :key="c.type" class="flex-grow-0">
          <TypeChart
            :class="c.type == type ? 'active-type ' : ''"
            :icon="c.icon"
            :title="c.name"
            :type="c.type"
            :img="c.img"
            @onClickType="(value) => (type = value)"
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <span style="color: red" v-if="typeError.length > 0">{{
            typeError[0]
          }}</span>
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <v-select
            v-model="period"
            label="Period"
            :items="periodList"
            variant="outlined"
            return-object
          ></v-select>
        </v-col>
        <v-col>
          <v-select
            v-model="factories"
            label="Factories"
            :items="factoryList"
            variant="outlined"
            multiple
            return-object
          ></v-select>
        </v-col>
      </v-row>
    </v-card-text>
    <v-row>
      <v-col>
        <v-divider />
      </v-col>
    </v-row>
    <v-card-actions>
      <v-row>
        <v-col align="left">
          <v-btn @click="$emit('close:dialog')">Cancel</v-btn>
        </v-col>
        <v-col align="right" v-if="mode != 'edit'">
          <v-btn color="primary" @click="onCreateHandler">Create</v-btn>
        </v-col>
        <v-col v-else align="right">
          <v-btn color="primary" @click="onSaveHandler">Save</v-btn>
        </v-col>
      </v-row>
    </v-card-actions>
  </v-card>
</template>

<script>
import { mapActions, mapState } from "pinia";
import TypeChart from "@/components/BaseCharts/TypeChart.vue";
import { useVuelidate } from "@vuelidate/core";
import { required } from "@vuelidate/validators";
import { useAppStore } from "@/store/app";
import { rowData } from "@/models/data";
import { chartTypes, periodList } from "@/models/widgetData";
import { generateId } from "@/utils/utils";

export default {
  name: "FormDashboard",
  emits: ["close:dialog", "close:all"],
  props: {
    widget: { type: String },
    data: { type: Object },
    dashboardId: { type: Number },
  },
  components: {
    TypeChart,
  },
  setup() {
    return { v$: useVuelidate() };
  },
  validations() {
    return {
      name: { required },
      type: { required },
    };
  },
  data() {
    return {
      name: null,
      chartType: chartTypes,
      type: null,
      periodList: periodList,
      period: null,
      factories: null,
      factoryList: [
        { title: "GR", value: "GR" },
        { title: "BG", value: "BG" },
        { title: "UK", value: "UK" },
        { title: "USA", value: "USA" },
      ],
      id: null,
    };
  },
  created() {
    if (this.mode == "edit") {
      this.name = this.data?.title;
      this.period = this.data?.period;
      this.factories = this.data?.factories;
      this.type = this.data?.type;
      this.id = this.data?.id;
    }
  },
  computed: {
    ...mapState(useAppStore, ["dashboard"]),
    mode() {
      if (this.data != undefined) {
        return "edit";
      } else {
        return "create";
      }
    },
    nameError() {
      const errors = [];
      if (!this.v$.name.$dirty) return errors;
      if (this.v$.name.$invalid) errors.push("Required !");
      return errors;
    },
    typeError() {
      const errors = [];
      if (!this.v$.type.$dirty) return errors;
      if (this.v$.type.$invalid) errors.push("Required !");
      return errors;
    },
  },
  methods: {
    ...mapActions(useAppStore, ["onAddChart", "onSetDashboard"]),
    onCreateHandler() {
      this.v$.$touch();
      if (this.v$.$invalid) return;
      var id = generateId(this.dashboard);

      let body = {
        id: id,
        title: this.name,
        type: this.type,
        period: this.period,
        widget: this.widget,
        dashboardId: this.dashboardId,
      };

      let data = rowData.filter((r) => {
        if (r.widget == this.widget) {
          return r;
        }
      });

      if (data.length > 0) {
        body.data = { labels: data[0].labels, datasets: data[0].datasets };
      }

      this.onAddChart(body);
      this.$emit("close:all");
    },
    onSaveHandler() {
      this.v$.$touch();
      if (this.v$.$invalid) return;
      let array = [...this.dashboard];

      array = array.map((a) => {
        if (a.id == this.id) {
          a.title = this.name;
          a.type = this.type;
          a.period = this.period;
          a.widget = this.widget;
          a.factories = this.factories;
        }
        return a;
      });
      this.onSetDashboard(array);
      this.$emit("close:all");
    },
  },
};
</script>

<style scoped>
.active-type {
  background-color: #cbdded;
}
</style>